<template>
  <div class="collections">
    <el-row style="height:6.4%">
      <div class="bullet-list-title">
        <div style="margin-left:15px;">
          <i class="el-icon-s-unfold"><b> 我的收藏 </b></i>
        </div>
      </div>
    </el-row>
    <el-row>
      <el-table
      :data="collections"
      style="width: 100%;margin-top:3%;height:90%">
      <el-table-column
        prop="_id"
        label="课号"
        align="center"
        >
      </el-table-column>
      <el-table-column
        prop="name"
        label="课程名称"
        >
      </el-table-column>
      <el-table-column label="操作">
      <template slot-scope="scope" width="100" align="center">

          <i class="el-icon-circle-plus-outline"
            @click="handleEdit(scope.$index, scope.row)"
            style="font-size:20px;"></i>
          &nbsp
          <i class="el-icon-delete"
            @click="handleDelete(scope.$index, scope.row)"
            style="font-size:20px;"></i>

      </template>
    </el-table-column>
    </el-table>
    </el-row>
  </div>
</template>

<script>

export default {
  data() {
    return {
      collections: [],
    };
  },
  methods:{
    handleEdit(index, row){
      // 先查课程详细信息
      var id=this.collections[index]._id;
      var url = '/api/courses/get-courses';
      this.$axios.get(url,
        {
          params:{
            _id: id,
          }

        }).then(response => {
        let tmp = response.data.courses[0];

        // 再查冲突课程
        url = '/api/courses/get-timetable';
        // 请求的参数对象
        var paramsObj = { email: this.$store.getters.getEmail };
        // 调用 axios.get() 发起 GET 请求
        this.$axios.get(url, { params: paramsObj }).then(res=> {
          // res.data 是服务器返回的数据
          var result = res.data.courses;
          for (var i = 0; i < result.length; i++) {
            if (id == result[i]._id) {
              this.$message({
                message: '该课程已选过',
                type: 'warning'
              });
              return;
            }
            else if (tmp.day == result[i].day && tmp.period == result[i].period) {
              this.$message({
                message: '该课程与已选课程时间段冲突',
                type: 'warning'
              });
              return;
            }
          }
          
          // 加入课程
          url='/api/user/courses';
          var data={'email':this.$store.getters.getEmail,'cid':id};
          this.$axios.post(url,data).then(res=>{
            // console.log(res);
          });
          window.location.reload();
        });
      }, response => {
        // console.log('error');
      });
    },
    handleDelete(index, row){
      var id=this.collections[index]._id;
      // console.log(id);
      var url='/api/user/collections';
      var params={'email':this.$store.getters.getEmail,'cid':id};
      this.$axios.delete(url,{data:params}).then(res=>{
        // console.log(res);
      });
      window.location.reload();
    }
  },
  created(){
    // 请求的 URL 地址
    var url = '/api/user/collections';
    // 请求的参数对象
    var paramsObj = { email:this.$store.getters.getEmail };
    // 调用 axios.get() 发起 GET 请求
    this.$axios.get(url, { params: paramsObj }).then(res=> {
      // res.data 是服务器返回的数据
      var result = res.data.collections;
      // console.log(result);
      this.collections=result;
    });
  }
};

</script>


<style scoped>

.collections {
  width:100%;
  height:100%;
  position: absolute;
  background-color: white;
  font-family: "Helvetica Neue",Helvetica,"PingFang SC","Hiragino Sans GB","Microsoft YaHei","微软雅黑",Arial,sans-serif;
}

.bullet-list-title {
  height: 100%;
  width: 100%;
  background-color: #f4f4f4;
  border-radius: 2px;
  text-align:left;
  font-weight: 800;
  font-size: 1.4em;
  display: flex;
  align-items: center;
}

</style>